#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name	= "Grenade Model",
	author	= "wS (World-Source.Ru)",
	version = "1.2"
};

new String:g_sModel[150], bool:g_bTrail;
new g_EffectEnt;

public OnPluginStart()
{
	new Handle:cvar = CreateConVar("he_model", "models/props/cs_italy/bananna.mdl");
	GetConVarString(cvar, g_sModel, 150);
	HookConVarChange(cvar, he_model);

	cvar = CreateConVar("he_trail", "1", "Хвост за боевой гранатой (1 вкл, 0 откл)");
	g_bTrail = GetConVarBool(cvar);
	HookConVarChange(cvar, he_trail);

	AutoExecConfig(true);
}

public OnMapStart()
{
	g_EffectEnt = PrecacheModel("materials/sprites/laser.vmt", true);
	if (g_sModel[0] == 'm') PrecacheModel(g_sModel, true);
}

///

public he_model(Handle:var, const String:old[], const String:NewValue[])
{
	if (StrContains(NewValue, "models") == 0 && StrContains(NewValue, ".mdl") != -1)
	{
		strcopy(g_sModel, 150, NewValue);
		PrecacheModel(g_sModel, true);
	}
	else
		g_sModel[0] = '\0';
}

public he_trail(Handle:var, const String:old[], const String:NewValue[])
{
	g_bTrail = StringToInt(NewValue) == 1;
}

///

public OnEntityCreated(entity, const String:classname[])
{
	if (strcmp(classname, "hegrenade_projectile", false) == 0)
		CreateTimer(0.1, OnHeSpawned, EntIndexToEntRef(entity), TIMER_FLAG_NO_MAPCHANGE);
}

public Action:OnHeSpawned(Handle:timer, any:entity)
{
	decl client;
	if ((entity = EntRefToEntIndex(entity)) > 0 && (client = GetEntPropEnt(entity, Prop_Data, "m_hThrower")) > 0 && IsClientInGame(client))
	{
		if (g_sModel[0] == 'm')
			SetEntityModel(entity, g_sModel);

		if (g_bTrail)
		{
			TE_SetupBeamFollow(entity, g_EffectEnt, g_EffectEnt, 3.0, 9.0, 4.0, 0, GetClientTeam(client) == 2 ? {255,0,0,255} : {0,0,255,255});
			TE_SendToAll();
		}
	}
	return Plugin_Stop;
}